# WAILA - What Am I Looking At?

Have you ever written anything like this code?

~~~
for item in dir(obj):
  print(item)
~~~

Use WAILA instead!

~~~
>>> from Waila import waila
>>> test = ['I', 'am', 'a', 'list']
>>> waila(test)
WAILA of object: ['I', 'am', 'a', 'list']

Name: append 
Help: Append object to the end of the list.
END OF ENTRY FOR append
**************************************************

Name: clear 
Help: Remove all items from list.
END OF ENTRY FOR clear
**************************************************

Name: copy 
Help: Return a shallow copy of the list.
END OF ENTRY FOR copy
**************************************************

Name: count 
Help: Return number of occurrences of value.
END OF ENTRY FOR count
**************************************************

Name: extend 
Help: Extend list by appending elements from the iterable.
END OF ENTRY FOR extend
**************************************************

Name: index 
Help: Return first index of value.

Raises ValueError if the value is not present.
END OF ENTRY FOR index
**************************************************

Name: insert 
Help: Insert object before index.
END OF ENTRY FOR insert
**************************************************

Name: pop 
Help: Remove and return item at index (default last).

Raises IndexError if list is empty or index is out of range.
END OF ENTRY FOR pop
**************************************************

Name: remove 
Help: Remove first occurrence of value.

Raises ValueError if the value is not present.
END OF ENTRY FOR remove
**************************************************

Name: reverse 
Help: Reverse *IN PLACE*.
END OF ENTRY FOR reverse
**************************************************

Name: sort 
Help: Stable sort *IN PLACE*.
END OF ENTRY FOR sort
**************************************************

Generated by waila - "what am I looking at" on Mon Jun 20 10:08:26 2022.
waila is a python utility developed by Asger Jon Vistisen
~~~

By default, waila prints the output to the console, ignoring dunder methods.
Use keywords such as print or dunder to adjust this behaviour. Use
keyword fid to save the output to a text file. See below for details.

## Installation

You can find the latest version on pypi: https://pypi.org/project/vistutils/
To install, simply run:

~~~
pip install vistutils
~~~

## waila - what am I looking at?

Instead of writing something like:

Simply use waila(obj)! This prints the name of each entry like above
including the documentation associated with the class of which the object
is an instance.

waila supports the following keyword arguments.

### print

Prints the contents found (default True)

### dunder

Includes dunder methods of the objects (default False)

### magic

alias for dunder (default False)

### getReturn

if True, waila(obj) returns items as a list of dictionaries with keys: '
name', 'type' and 'help' (default False)

### fid

saves the results to a text file of this name.

### save

if True, saves results to textfile, ignored if fid is given, otherwise a
filename is generated, which includes the name of the object and the time of
save. (default False)
